#!/bin/sh

# $Revision: 1.2 $
# $Date: 2004/06/15 09:44:39 $
 

# User parameters

MYSQL_HOME=/usr/local       	# MySQL install prefix
voms_database=VOMS		# Name of the VOMS database
dba_name="root"			# Database id of the db administrator
dba_pwd=""			# Password of the db administrator
vomsadmin_name="vomsadmin"	# Database id for the VOMS administrator
vomsadmin_pwd=""	        # Password of the VOMS administrator
vomsupdate_name="vomsupd"	# Database id for the VOMS updater role
vomsupdate_pwd=""	        # Password of the VOMS updater role
vomsread_name="voms"	        # Database id for the VOMS reader role
vomsread_pwd=""	                # Password of the VOMS reader role
vomssequence_name="vomsseq"	# Database id for the VOMS sequence role
vomssequence_pwd=""	        # Password of the VOMS sequence role
voms_vo=""			# VOMS VO name


# you may put the dba_pwd outside the CVS tree
#if [ -r "$HOME/.mysql.pwd" ]; then
#	source $HOME/.mysql.pwd
#fi

#if [ "x$MYSQL_HOME" = "x" ]; then
#    echo "Please set MYSQL_HOME." >&2
#    exit 1;
#fi

#if [ "x$dba_name" = "x" ]; then
#    echo    "Please enter the database userid of the MySQL">&2
#    echo -n "database administrator: " >&2
#    read dba_name
#fi

if [ "x$dba_pwd" = "x" ]; then
    echo -n "Please enter password for MySQL $dba_name user: " >&2
    stty -echo
    read dba_pwd
    stty echo
    echo ""
fi

#if [ "x$vomsadmin_name" = "x" ]; then
#    echo -n "Please enter the database userid of the VOMS daemon: ">&2
#    read vomsadmin_name
#fi

if [ "x$vomsadmin_pwd" = "x" ]; then
    echo -n "Please enter the database password for $vomsadmin_name user: " >&2
    stty -echo
    read vomsadmin_pwd
    stty echo
    echo ""
fi

#install -d /etc/sysconfig
#touch /etc/sysconfig/voms.pass
#chmod 600 /etc/sysconfig/voms.pass
#echo $vomsadmin_pwd > /etc/sysconfig/voms.pass
#chmod 400 /etc/sysconfig/voms.pass

#if [ "x$vomsupdate_name" = "x" ]; then
#    echo -n "Please enter the database userid of the VOMS update user: ">&2
#    read vomsupdate_name
#fi

if [ "x$vomsupdate_pwd" = "x" ]; then
    echo -n "Please enter the database password for $vomsupdate_name user: " >&2
    stty -echo
    read vomsupdate_pwd
    stty echo
    echo ""
fi

#if [ "x$vomssequence_name" = "x" ]; then
#    echo -n "Please enter the database userid of the VOMS sequence user: ">&2
#    read vomssequence_name
#fi

if [ "x$vomssequence_pwd" = "x" ]; then
    echo -n "Please enter the database password for $vomssequence_name user: " >&2
    stty -echo
    read vomssequence_pwd
    stty echo
    echo ""
fi

#if [ "x$vomsread_name" = "x" ]; then
#    echo -n "Please enter the database userid of the VOMS read user: ">&2
#    read vomsread_name
#fi

if [ "x$vomsread_pwd" = "x" ]; then
    echo -n "Please enter the database password for $vomsread_name user: " >&2
    stty -echo
    read vomsread_pwd
    stty echo
    echo ""
fi

basepath=$EDG_LOCATION/etc
if [ "x$EDG_LOCATION" = "x" ]; then
    basepath=/
fi

datapath=$(basepath)/etc

install -d $datapath
touch $datapath/voms.pass
chmod 600 $datapath/voms.pass
echo $vomsadmin_pwd > $datapath/voms.pass
chmod 400 $datapath/voms.pass

if [ "x$voms_vo" = "x" ]; then
    echo -n "Please enter the VO name for this VOMS instance: " >&2
    read voms_vo
fi

echo -e "f $(datapath)/voms.var.out\n%s/\$$VO/\\\\`echo \$$voms_vo`/g\nwq"|ed $(datapath)/voms.var >/dev/null 2>/dev/null
echo -e "f $(datapath)/voms.var.out2\n%s/\$$PASSFILE/\\\\`echo \$$datapath/voms.pass`/g\nwq"|ed $(datapath)/voms.var.out >/dev/null 2>/dev/null
rm -f $(datapath)/voms.var $(datapath/voms.var.out)
mv $(datapath)/voms.var.out2 $(datapath)/voms.var

# Derived parameters
MYSQLADMIN="$MYSQL_HOME/bin/mysqladmin -u $dba_name -p$dba_pwd"
MYSQLDBA="$MYSQL_HOME/bin/mysql -u $dba_name -p$dba_pwd"
MYSQLVOMS="$MYSQL_HOME/bin/mysql -u $vomsadmin_name -p$vomsadmin_pwd"

#  Create Database

$MYSQLDBA -e "DROP DATABASE IF EXISTS $voms_database;
              CREATE DATABASE $voms_database;"

#  Create Tables

$MYSQLDBA -D $voms_database < $(datapath)/voms.data

#
# Create voms users
#

$MYSQLDBA -e "GRANT ALL PRIVILEGES ON $voms_database.* to vomsadmin IDENTIFIED BY '$vomsadmin_pwd' WITH GRANT OPTION;
  GRANT ALL PRIVILEGES ON $voms_database.* to vomsadmin@localhost IDENTIFIED BY '$vomsadmin_pwd' WITH GRANT OPTION;

  GRANT ALL PRIVILEGES ON $voms_database.* TO $vomsread_name IDENTIFIED BY '$vomsread_pwd';
  GRANT LOCK TABLES ON $voms_database.* to $vomsread_name IDENTIFIED BY '$vomsread_pwd';
  REVOKE ALTER ON $voms_database.* FROM $vomsread_name;
  REVOKE CREATE ON $voms_database.* FROM $vomsread_name;
  REVOKE DROP ON $voms_database.* FROM $vomsread_name;
  REVOKE UPDATE ON $voms_database.* FROM $vomsread_name;
  REVOKE DELETE ON $voms_database.* FROM $vomsread_name;
  REVOKE INSERT ON $voms_database.* FROM $vomsread_name;

  GRANT ALL PRIVILEGES ON $voms_database.* TO $vomsread_name@localhost IDENTIFIED BY '$vomsread_pwd';
  GRANT LOCK TABLES ON $voms_database.* to $vomsread_name@localhost IDENTIFIED BY '$vomsread_pwd';
  REVOKE ALTER ON $voms_database.* FROM $vomsread_name@localhost;
  REVOKE CREATE ON $voms_database.* FROM $vomsread_name@localhost;
  REVOKE DROP ON $voms_database.* FROM $vomsread_name@localhost;
  REVOKE UPDATE ON $voms_database.* FROM $vomsread_name@localhost;
  REVOKE DELETE ON $voms_database.* FROM $vomsread_name@localhost;
  REVOKE INSERT ON $voms_database.* FROM $vomsread_name@localhost;

  GRANT ALL PRIVILEGES ON $voms_database.* TO $vomsupdate_name IDENTIFIED BY '$vomsupdate_pwd';
  REVOKE ALTER ON $voms_database.* FROM $vomsupdate_name;
  REVOKE CREATE ON $voms_database.* FROM $vomsupdate_name;
  REVOKE DROP ON $voms_database.* FROM $vomsupdate_name;

  GRANT ALL PRIVILEGES ON $voms_database.* TO $vomsupdate_name@localhost IDENTIFIED BY '$vomsupdate_pwd';
  REVOKE ALTER ON $voms_database.* FROM $vomsupdate_name@localhost;
  REVOKE CREATE ON $voms_database.* FROM $vomsupdate_name@localhost;
  REVOKE DROP ON $voms_database.* FROM $vomsupdate_name@localhost;

  GRANT ALL PRIVILEGES ON $voms_database.* TO $vomssequence_name IDENTIFIED BY '$vomssequence_pwd';
  REVOKE ALTER ON $voms_database.* FROM $vomssequence_name;
  REVOKE CREATE ON $voms_database.* FROM $vomssequence_name;
  REVOKE DROP ON $voms_database.* FROM $vomssequence_name;
  REVOKE UPDATE ON $voms_database.* FROM $vomssequence_name;
  REVOKE DELETE ON $voms_database.* FROM $vomssequence_name;
  REVOKE INSERT ON $voms_database.* FROM $vomssequence_name;
  GRANT UPDATE ON $voms_database.sequences TO $vomssequence_name;
  GRANT INSERT ON $voms_database.sequences TO $vomssequence_name;

  GRANT ALL PRIVILEGES ON $voms_database.* TO $vomssequence_name@localhost IDENTIFIED BY '$vomssequence_pwd';
  REVOKE ALTER ON $voms_database.* FROM $vomssequence_name@localhost;
  REVOKE CREATE ON $voms_database.* FROM $vomssequence_name@localhost;
  REVOKE DROP ON $voms_database.* FROM $vomssequence_name@localhost;
  REVOKE UPDATE ON $voms_database.* FROM $vomssequence_name@localhost;
  REVOKE DELETE ON $voms_database.* FROM $vomssequence_name@localhost;
  REVOKE INSERT ON $voms_database.* FROM $vomssequence_name@localhost;
  GRANT UPDATE ON $voms_database.sequences TO $vomssequence_name@localhost;
  GRANT INSERT ON $voms_database.sequences TO $vomssequence_name@localhost;

  FLUSH PRIVILEGES;"

#
#  Populate database
#

$MYSQLVOMS -D $voms_database <<EOF
-- The transaction counter.  The first real transaction will get CreatedSerial=1. 
INSERT INTO sequences VALUES ('transaction', 0);
-- The dummy CA for local administrators bypassing the security infrastructure. 
INSERT INTO ca VALUES (1, "/O=VOMS/O=System/CN=Dummy Certificate Authority", "A dummy CA for local database maintenance.");
-- The database administrator responsible for these bootstrap records. 
INSERT INTO admins VALUES (1, "/O=VOMS/O=System/CN=Local Database Administrator", 1, 1, 0);
-- The ACL of the VO Group.  The DBA can do everything.  
-- (Just a placeholder, since the DBA doesn't really need ACLs.) 
INSERT INTO acl VALUES (1, 1, 1, 1, 1, 0);
-- The Default ACL of the VO Group.
INSERT INTO acl VALUES (2, 1, 1, 1, 1, 0);
-- The VO Group.
INSERT INTO groups VALUES (1, "$voms_vo", 0, 1, 2, 1, 0, NULL);
-- The first timestamp record.
INSERT INTO realtime VALUES (0, current_timestamp);
EOF

./gen_ca_sql.pl | $MYSQLVOMS -D $voms_database
